var ldsToolTip = function(options){
 
    var vars = {
        el  : null,
        href: null,
        scripture: null,
        book: null,
        chapter: null,
        verse: null,
        speed:400,
        summary:true,
        root: null,
        prevent:false
    };
    var s = false;
 
    var root = this;
 
    this.construct = function(options){

        vars.href = jQuery(options.el).attr('href');
        jQuery.extend(vars , options);

    };

    var setupLink = function() {

        if (jQuery(vars.el).attr('href').indexOf("www.lds.org/scriptures/") > -1) {

            if(!jQuery(vars.el).hasClass("lds-tooltip")) {
                jQuery(vars.el).addClass("lds-tooltip")
            }
            if( jQuery(vars.el).css('position').toLowerCase() != 'relative' && jQuery(vars.el).css('position').toLowerCase() != 'absolute') {
                jQuery(vars.el).css("position", "relative");
            }
            return true;
        } else {
            return false;
        }

    }

    var getLink = function() {

        if (vars.scripture != null &&
            vars.book != null &&
            vars.chapter != null &&
            vars.verse != null) {
            return;
        }

        var link = vars.href;
        link = link.replace('https://www.lds.org/scriptures/','');
        link = link.replace('http://www.lds.org/scriptures/','');
        if (link.search('#') != -1) {
            link = link.substring(0, link.indexOf('#'));
        }
        link = link.replace('.','/');
        link = link.split("/");
        var newVars = {
            scripture: link[0],
            book: link[1],
            chapter: link[2],
            verse: link[3]
        };
        if (newVars['verse'] == undefined) {
            if(vars.summary == false) {
                vars.prevent = true;
            } else {
                root.s = true;
            }
        }
        jQuery.extend(vars , newVars);
    }

    var getContent = function() {

        var fullLink = vars.root + "?scripture=" + vars.scripture +"&book=" + vars.book + "&chapter=" + vars.chapter;
        if (!root.s) fullLink += "&verse=" + vars.verse;
        
        var find = '.verse.active-item';
        if (root.s) find = '.study-summary';

        var content = jQuery.get( fullLink, function(data) {
            // console.log( "success" );
            vars.content = data;

        })
        .done(function() {
            // console.log( "done" );
        })
        .fail(function() {
            vars.fail = true;
            // console.log( "fail" );
        })
        .always(function() {
            // console.log( "always" );
        });

    }

    var leftOrRight = function() {

        var rect = jQuery(vars.el).find('.lds-tooltip-content')[0].getBoundingClientRect();
        var leftFromLeft = rect.left;
        var rightFromRight = jQuery( window ).width() - rect.right;

        if (leftFromLeft < 15) {
            var toMove = 15 + (leftFromLeft * -1);
            jQuery(vars.el).find('.lds-tooltip-content').css("left", "calc(50% + " + toMove + "px)");
        } else if ( rightFromRight < 15) {
            var toMove = 15 + ( rightFromRight * -1);
            jQuery(vars.el).find('.lds-tooltip-content').css("left", "calc(50% - " + toMove + "px)");
        }

    }

    var topOrBottom = function() {

        var elementTop = jQuery(vars.el).find('.lds-tooltip-content').offset().top;
        var elementHeight = jQuery(vars.el).find('.lds-tooltip-content').outerHeight()
        var elementBottom = elementTop + elementHeight;
        var AmountScrolled = jQuery(window).scrollTop();
        var windowHeight = jQuery(window).height();

        var bottomFromBottom = windowHeight - (elementBottom - AmountScrolled);

        if (bottomFromBottom > 15) {
            jQuery(vars.el).find('.lds-tooltip-content').addClass("below");
            return;
        }

        var linkTop = jQuery(vars.el).offset().top;
        var spaceAboveLink = linkTop - AmountScrolled;
        var couldFitAbove = spaceAboveLink - elementHeight;

        if (couldFitAbove > 15) {
            jQuery(vars.el).find('.lds-tooltip-content').addClass("above");
        }

    }

    var putLdsToolTip = function() {

        if (vars.fail || vars.content == null || vars.prevent == true) {
            return;
        }
        jQuery(vars.el).append("<div class='lds-tooltip-content' style='opacity:0;'>" + vars.content + "</div>");

        leftOrRight();
        topOrBottom();

        jQuery(vars.el).find('.lds-tooltip-content').fadeTo(vars.speed,1);

    }

    var removeLdsToolTip = function() {

        if (vars.fail || vars.content == null) {
            return;
        }
        jQuery(vars.el).find('.lds-tooltip-content').fadeOut(vars.speed, function() {
            jQuery(vars.el).find('.lds-tooltip-content').remove();
        });

    }

    this.construct(options);
    if ( setupLink() ) {
        getLink();
        getContent();
    }

    jQuery(vars.el).hover(  function() {
        putLdsToolTip();
    }, function() {
        removeLdsToolTip();
    });
 
};